commit d7da3378e7997a3596dbd79985e7271e1db7050c
Author: freddy77 <freddy77>
Date:   Thu Aug 20 17:49:07 2009 +0000

    use iconv on variant

diff --git a/ChangeLog b/ChangeLog
index 932a125..3530cbe 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Thu Aug 20 19:48:56 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/tds/data.c src/tds/token.c src/tds/types.pl:
+	- use iconv on variant
+
 Thu Aug 20 17:14:29 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc.c: fix describecol test
 
@@ -1747,4 +1751,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2847 2009/08/20 15:14:18 freddy77 Exp $
+$Id: ChangeLog,v 1.2848 2009/08/20 17:49:07 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index a61e13b..974f0d4 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.316 2009/07/20 17:38:12 freddy77 Exp $ */
+/* $Id: tds.h,v 1.317 2009/08/20 17:49:07 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1429,6 +1429,7 @@ BCPCOLDATA * tds_alloc_bcp_column_data(int column_size);
 unsigned char *tds7_crypt_pass(const unsigned char *clear_pass, size_t len, unsigned char *crypt_pass);
 TDSDYNAMIC *tds_lookup_dynamic(TDSSOCKET * tds, const char *id);
 /*@observer@*/ const char *tds_prtype(int token);
+int tds_get_varint_size(TDSSOCKET * tds, int datatype);
 
 
 
diff --git a/src/tds/data.c b/src/tds/data.c
index 1455667..f9d08c9 100644
--- a/src/tds/data.c
+++ b/src/tds/data.c
@@ -35,11 +35,10 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: data.c,v 1.21 2009/06/09 06:50:12 freddy77 Exp $");
+TDS_RCSID(var, "$Id: data.c,v 1.22 2009/08/20 17:49:07 freddy77 Exp $");
 
 #if !ENABLE_EXTRA_CHECKS
 static int tds_get_cardinal_type(int datatype);
-static int tds_get_varint_size(TDSSOCKET * tds, int datatype);
 #endif
 
 /**
diff --git a/src/tds/token.c b/src/tds/token.c
index 39f4b66..c015b96 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.367 2009/08/19 11:47:52 freddy77 Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.368 2009/08/20 17:49:07 freddy77 Exp $");
 
 #define USE_ICONV tds->use_iconv
 
@@ -2015,6 +2015,9 @@ tds7_get_variant(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		tds_get_n(tds, v->collation, sizeof(v->collation));
 		colsize -= sizeof(v->collation);
 		info_len -= sizeof(v->collation);
+		curcol->char_conv =
+			tds_iconv_from_collate(tds, v->collation[4],
+					       v->collation[1] * 256 + v->collation[0]);
 	}
 	/* special case for numeric */
 	if (is_numeric_type(type)) {
@@ -2058,11 +2061,22 @@ tds7_get_variant(TDSSOCKET * tds, TDSCOLUMN * curcol)
 	curcol->column_cur_size = colsize;
 	if (v->data)
 		TDS_ZERO_FREE(v->data);
-	v->data_len = colsize;
 	if (colsize) {
-		v->data = (TDS_CHAR*) malloc(colsize);
-		tds_get_n(tds, v->data, colsize);
+		if (USE_ICONV && curcol->char_conv) {
+			curcol->column_cur_size = colsize = determine_adjusted_size(curcol->char_conv, colsize);
+			v->data = (TDS_CHAR*) malloc(colsize);
+			if (!v->data)
+				return TDS_FAIL;
+			if (tds_get_char_data(tds, (char *) v->data, colsize, curcol) == TDS_FAIL)
+				return TDS_FAIL;
+		} else {
+			v->data = (TDS_CHAR*) malloc(colsize);
+			if (!v->data)
+				return TDS_FAIL;
+			tds_get_n(tds, v->data, colsize);
+		}
 	}
+	v->data_len = colsize;
 	return TDS_SUCCEED;
 
 error_type:
diff --git a/src/tds/types.pl b/src/tds/types.pl
index a4cd760..bcdf973 100755
--- a/src/tds/types.pl
+++ b/src/tds/types.pl
@@ -31,7 +31,7 @@ while ($line = readLine()) {
 	$types{$type{'name'}} = \%type;
 }
 
-my $id = '$Id: types.pl,v 1.1 2008/09/17 12:16:09 freddy77 Exp $';
+my $id = '$Id: types.pl,v 1.2 2009/08/20 17:49:07 freddy77 Exp $';
 $id =~ s/\$Id/CVS Id/;
 $id =~ s/\$\s*$//;
 print qq|/*
@@ -78,9 +78,6 @@ print q|/**
  * tds_get_varint_size() returns the size of a variable length integer
  * returned in a TDS 7.0 result string
  */
-#if !ENABLE_EXTRA_CHECKS
-static
-#endif
 int
 tds_get_varint_size(TDSSOCKET * tds, int datatype)
 {

